//-----------------------------------------------------------------------------
//    API_2_ERH_CPRVS_BSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_erh_cprvs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.EnvelopeResponseHandler.compareValue(short, byte[], short, short) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 07/12/00
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.EnvelopeResponseHandler
 */
public class API_2_ERH_CPRVS_BSS_1 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;
    
    /**
     * Constructor of the applet
     */
    public API_2_ERH_CPRVS_BSS_1() 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ERH_CPRVS_BSS_1 thisApplet = new API_2_ERH_CPRVS_BSS_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of the EnvelopeResponseHandler class
        EnvelopeResponseHandler EnvRespHdlr = EnvelopeResponseHandler.getTheHandler() ;

        // --------------------------------------------
        // Test Case 1 : Null as compareBuffer
        testCaseNb = (byte) 1 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.compareValue((short)0, null, (short)0, (short)1) ;
                
            }
			catch (NullPointerException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 2 : compareOffset >= compareBuffer.length
        testCaseNb = (byte) 2 ;
        bRes = false ;
        byte[] compareBuffer=new byte[5];
			
		try {
            
			byte[] TLVBuffer=new byte[16];
		
			//initialize the buffer
			for(short i=0;i<16;i++)
				TLVBuffer[i]=(byte)i;
			
			//built the first tlv
			EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 16);
			
			// Select Text String TLV
			EnvRespHdlr.findTLV((byte)0x0D, (byte)1) ;
        
            try {
                EnvRespHdlr.compareValue((short)0, compareBuffer, (short)5, (short)1) ;
                
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 3 : compareOffset < 0
        testCaseNb = (byte) 3 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.compareValue((short)0, compareBuffer, (short)-1, (short)1) ;
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 4 : compareLength > compareBuffer.length
        testCaseNb = (byte) 4 ;
        bRes = false ;
        
        try {
            
            try {
                EnvRespHdlr.compareValue((short)0, compareBuffer, (short)0, (short)6) ;
                
            } catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 5 : compareOffset + compareLength > compareBuffer.length
        testCaseNb = (byte) 5 ;
        bRes = false ;
        
        try {
            
            try {
                EnvRespHdlr.compareValue((short)0, compareBuffer, (short)3, (short)3) ;
                
            } catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 6 : compareLength < 0

        
       testCaseNb = (byte) 6 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.compareValue((short)0, compareBuffer, (short)0, (short)-1) ;
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 7 : valueOffset >= Text String Length
        testCaseNb = (byte) 7 ;
        bRes = false ;
        
		compareBuffer=new byte[15];
			
        try {
			
			//initialize the buffer
			for(short i=0;i<15;i++)
				compareBuffer[i]=(byte)i;
			
            EnvRespHdlr.clear();
			//built the first tlv
			EnvRespHdlr.appendTLV((byte)0x0D,compareBuffer,(short) 0x00, (short) 6);
			
			// Select Text String TLV
			EnvRespHdlr.findTLV((byte)0x0D, (byte)1) ;
        
			try {
                EnvRespHdlr.compareValue((short)6, compareBuffer, (short)0, (short)1) ;
                
            } catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 8 : valueOffset < 0
        testCaseNb = (byte) 8 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.compareValue((short)-1, compareBuffer, (short)0, (short)1) ;
            }
			catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 9 : compareLength > Text String length
        testCaseNb = (byte) 9 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.compareValue((short)0, compareBuffer, (short)0, (short)7) ;
            }
			catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 10 : valueOffset + compareLength > Text String length
        testCaseNb = (byte) 10 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.compareValue((short)2, compareBuffer, (short)0, (short)5) ;
            }
			catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 11 : Unavailable element
        testCaseNb = (byte) 11 ;
        bRes = false ;
        
        try {
            //clear the handler
			EnvRespHdlr.clear();
            try {
                EnvRespHdlr.compareValue((short)0, compareBuffer, (short)0, (short)1) ;
            }
			catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 12 : Successfull call
        testCaseNb = (byte) 12 ;
        bRes = false ;

        
		compareBuffer = new byte[17] ;
    
		// Initialise compare buffer
        compareBuffer[0] = 4;
		for (short i=1; i<17; i++)
            compareBuffer[i] = (byte)(i-1) ;

		
		EnvRespHdlr.clear();

		//built the first tlv
		EnvRespHdlr.appendTLV((byte)0x0D,compareBuffer,(short) 0x00, (short) 17);
		
        // Search Text String TLV
        EnvRespHdlr.findTLV((byte)0x0D, (byte)0x01) ;
            
		try {
            // Compare TLV
            if(EnvRespHdlr.compareValue((short)0, compareBuffer, (short)0, (short)17)==0)
				bRes=true;
		}
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 13 : Successfull call
        testCaseNb = (byte) 13 ;
        bRes = false ;
		
		compareBuffer[16] = (byte)0x10 ;
        
		try {
            // Compare TLV
            if(EnvRespHdlr.compareValue((short)0, compareBuffer, (short)0, (short)17)==-1)
				bRes=true;
		}
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 14 : Successfull call
        testCaseNb = (byte) 14 ;
        bRes = false ;

        // Initialise compareBuffer
        compareBuffer[0] = (byte)0x03;
        compareBuffer[16] = (byte)0x0F;
        
        try {
            // Compare TLV
            if(EnvRespHdlr.compareValue((short)0, compareBuffer, (short)0, (short)17)==+1)
				bRes=true;
		}
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 15 : Successfull call
        testCaseNb = (byte) 15 ;
        bRes = false ;

        compareBuffer = new byte[20];

		// Initialise compareBuffer
        Util.arrayFillNonAtomic(compareBuffer,(short)0,(short)20,(byte)0x55);
		for(short i=3;i<15;i++)
			compareBuffer[i]=(byte)(i-2);

		try {
            // Compare TLV
            if(EnvRespHdlr.compareValue((short)2, compareBuffer, (short)3, (short)12)==0)
				bRes=true;
		}
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 16 : Successfull call
        testCaseNb = (byte) 16 ;
        bRes = false ;

        // Initialise compareBuffer
        compareBuffer[3] = (byte) 0x02 ;
        compareBuffer[4] = (byte) 0x01 ;
        
        try {
            // Compare TLV
            if(EnvRespHdlr.compareValue((short)2, compareBuffer, (short)3, (short)12)==-1)
				bRes = true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 17 : Successfull call
        testCaseNb = (byte) 17 ;
        bRes = false ;

        // Initialise compareBuffer
        compareBuffer[3] = (byte) 0x01 ;
        compareBuffer[4] = (byte) 0x02 ;
        compareBuffer[13] = (byte) 0x0A ;
        compareBuffer[14] = (byte) 0x0D ;
        
        try {
            // Compare TLV
            if(EnvRespHdlr.compareValue((short)2, compareBuffer, (short)3, (short)12)==+1)
				bRes = true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
		
		// --------------------------------------------
        // Test Case 18 : Successfull call (with the length = 0 and the offset = length of the comparaison buffer)
        testCaseNb = (byte) 18 ;
        bRes = false ;

        try {
            // Compare TLV
            if(EnvRespHdlr.compareValue((short)2, compareBuffer, (short)compareBuffer.length, (short)0)==0)
				bRes = true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
	}
}
