//-----------------------------------------------------------------------------
//    API_2_ERH_FACYBBS_BSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_erh_facybbs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.EnvelopeResponseHandler.findAndCopyValue(byte, byte, short, byte[], short, short) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 07/12/00
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.EnvelopeResponseHandler
 */
public class API_2_ERH_FACYBBS_BSS_1 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;
    
    /**
     * Constructor of the applet
     */
    public API_2_ERH_FACYBBS_BSS_1() 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ERH_FACYBBS_BSS_1 thisApplet = new API_2_ERH_FACYBBS_BSS_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes, bRes2 ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of the EnvelopeResponseHandler class
        EnvelopeResponseHandler EnvRespHdlr = EnvelopeResponseHandler.getTheHandler() ;

        // --------------------------------------------
        // Test Case 1 : Null as dstBuffer
        testCaseNb = (byte) 1 ;
        bRes = false ;
        
        try {
            
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (byte)0, null, (byte)0, (byte)1) ;
                
            } catch (NullPointerException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 2 : dstOffset >= dstBuffer.length
        testCaseNb = (byte) 2 ;
        bRes = false ;
        
		byte[] TLVBuffer=new byte[20];
		byte[] dstBuffer=new byte[5];
		
		
		try {
            //initialize the buffer
			for(short i=1;i<17;i++)
				TLVBuffer[i]=(byte)(i-1);
			TLVBuffer[0]=(byte)4;
			
			//built the first tlv
			EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 16);
            
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (byte)0, dstBuffer, (byte)5, (byte)1) ;
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 3 : dstOffset < 0
        testCaseNb = (byte) 3 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (byte)0, dstBuffer, (byte)-1, (byte)1) ;
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 4 : dstLength > dstBufferLength
        testCaseNb = (byte) 4 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)0, dstBuffer, (short)0, (short)6) ;
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 5 : dstOffset + dstLength > dstBuffer.length
        testCaseNb = (byte) 5 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)0, dstBuffer, (short)3, (short)3) ;
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 6 : dstLength < 0
        testCaseNb = (byte) 6 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)0, dstBuffer, (short)0, (short)-1) ;
            }
			catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
        
        // --------------------------------------------
        // Test Case 7 : valueOffset >= Text String Length
        testCaseNb = (byte) 7 ;
        bRes = false ;
        dstBuffer=new byte[15];

        try {
            // Initialise the handler
            EnvRespHdlr.clear();
			EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 6);
                       
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)6, dstBuffer, (short)0, (short)1) ;
            }
			catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 8 : valueOffset < 0
        testCaseNb = (byte) 8 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)-1, dstBuffer, (short)0, (short)1) ;
            }
			catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 9 : dstLength > Text String length
        testCaseNb = (byte) 9 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)0, dstBuffer, (short)0, (short)7) ;
                
            }
			catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 10 : valueOffset + dstLength > Text String Length
        testCaseNb = (byte) 10 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)2, dstBuffer, (short)0, (short)5) ;
            }
			catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 11 : Unavailable Element
        testCaseNb = (byte) 11 ;
        bRes = false ;

        // Initialise the handler
        EnvRespHdlr.clear();
		TLVBuffer[0]=(byte)0x11;
		TLVBuffer[2]=(byte)0x22;
		EnvRespHdlr.appendTLV((byte)0x02,TLVBuffer,(short) 0x00, (short) 2);
        
        // Select a TLV
        EnvRespHdlr.findTLV(TAG_DEVICE_IDENTITIES, (byte)1) ;
        
        try {
            EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)2, (short)0, dstBuffer, (short)0, (short)1) ;
        }
		catch (ToolkitException e) {
            bRes = (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT) ;
        }
        
		 reportTestOutcome(testCaseNb, bRes) ;

		testCaseNb = (byte) 12 ;
        bRes = false ;


        // Verify there is no current TLV
        try {
            EnvRespHdlr.getValueLength() ;
        } catch (ToolkitException e) {
            bRes = (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT) ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 12 : Successful call
        testCaseNb = (byte) 13 ;
        bRes = false ;
        dstBuffer = new byte[17];

        try {
            
            // Initialise buffer
            for(short i=1;i<17;i++)
				TLVBuffer[i]=(byte)(i-1);
			TLVBuffer[0]=(byte)4;
			
            // Initialise the handler
            EnvRespHdlr.clear();
			EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 17);
                    
            if(EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)0, dstBuffer, (short)0, (short)17)==(short)17)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 13 : Compare buffer
        testCaseNb = (byte) 14 ;
        bRes = false ;
        
        try {
            if(Util.arrayCompare(TLVBuffer, (short)0, dstBuffer, (short)0, (short)17)==0)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 14 : Successful call
        testCaseNb = (byte) 15 ;
        bRes = false ;
        dstBuffer=new byte[20];
        try {
            Util.arrayFillNonAtomic(dstBuffer,(short)0,(short)dstBuffer.length,(byte)0x55);
		    
            if(EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)2, dstBuffer, (short)3, (short)12)==15)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
        
        // --------------------------------------------
        // Test Case 15 : Compare buffer
        testCaseNb = (byte) 16 ;
        bRes = false ;
        
        try {
            
            Util.arrayFillNonAtomic(TLVBuffer,(short)0,(short)TLVBuffer.length,(byte)0x55);
		    // Initialise compare buffer
            for (short i=3; i<15; i++) 
                TLVBuffer[i] = (byte)(i-2) ;
            
            if(Util.arrayCompare(TLVBuffer, (short)0, dstBuffer, (short)0, (short)20)==0)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 16 : Successful call with 2 Text String TLV
        testCaseNb = (byte) 17 ;
        bRes = false ;
        
		dstBuffer=new byte[17];
        try {

            TLVBuffer[0] = (byte) 0x00 ;
            TLVBuffer[1] = (byte) 0x11 ;
            TLVBuffer[2] = (byte) 0x22 ;
            TLVBuffer[3] = (byte) 0x33 ;
            TLVBuffer[4] = (byte) 0x44 ;
            TLVBuffer[5] = (byte) 0x55 ;
            
			//add a second TLV
			EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 6);
            
            if(EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)1, (short)0, dstBuffer, (short)0, (short)17)==(short)17)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 17 : Compare buffer
        testCaseNb = (byte) 18 ;
        bRes = false ;
        
        try {
			//initialize the compare buffer
			for(short i=1;i<17;i++)
				TLVBuffer[i]=(byte)(i-1);
			TLVBuffer[0]=(byte)4;
			
			if(Util.arrayCompare(TLVBuffer, (short)0, dstBuffer, (short)0, (short)17)==0)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
        
        // --------------------------------------------
        // Test Case 18 : Successful call with 2 Text String TLV
        testCaseNb = (byte) 19 ;
        bRes = false ;
        
		dstBuffer=new byte[6];

        try {

            if(EnvRespHdlr.findAndCopyValue((byte)0x0D, (byte)2, (short)0, dstBuffer, (short)0, (short)6)==(short)6)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 19 : Compare buffer
        testCaseNb = (byte) 20 ;
        bRes = false ;
        
        try {

            TLVBuffer[0] = (byte) 0x00 ;
            TLVBuffer[1] = (byte) 0x11 ;
            TLVBuffer[2] = (byte) 0x22 ;
            TLVBuffer[3] = (byte) 0x33 ;
            TLVBuffer[4] = (byte) 0x44 ;
            TLVBuffer[5] = (byte) 0x55 ;
            
            if(Util.arrayCompare(TLVBuffer, (short)0, dstBuffer, (short)0, (short)6)==0)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;



        // --------------------------------------------
        // Test Case 20 : Successful call, tag = 8Dh
        testCaseNb = (byte) 21 ;
        bRes = false ;
        
		dstBuffer=new byte[17];

        //initialize the compare buffer
		for(short i=1;i<17;i++)
			TLVBuffer[i]=(byte)(i-1);
		TLVBuffer[0]=(byte)4;
		
		    
		try {
            
            // Initialise handler
            EnvRespHdlr.clear();
			//add the first TLV
			EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 17);
        
			if(EnvRespHdlr.findAndCopyValue((byte)0x8D, (byte)1, (short)0, dstBuffer, (short)0, (short)17)==(short)17)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
        
        // --------------------------------------------
        // Test Case 21 : Compare buffer
        testCaseNb = (byte) 22 ;
        bRes = false ;
        
        try {
            
            if(Util.arrayCompare(TLVBuffer, (short)0,dstBuffer, (short)0, (short)17)==0)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 22 : Successful call, tag = 8Fh
        testCaseNb = (byte) 23 ;
        bRes = false ;
        
		dstBuffer=new byte[16];

        //initialize the compare buffer
		for(short i=1;i<16;i++)
			TLVBuffer[i]=(byte)(i-1);
		TLVBuffer[0]=(byte)4;
		
        try {
            
            // Append TLV with tag 0Fh
            EnvRespHdlr.appendTLV((byte)0x0F,TLVBuffer,(short) 0x01, (short) 16);
        
            // Search tag 8Fh
            if(EnvRespHdlr.findAndCopyValue((byte)0x8F, (byte)1, (short)0, dstBuffer, (short)0, (short)16)==(short)16)
				bRes = true ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 23 : Compare buffer
        testCaseNb = (byte) 24 ;
        bRes = false ;
        
        try {
            
            if(Util.arrayCompare(TLVBuffer, (short)1,dstBuffer, (short)0, (short)16)==0)
				bRes=true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 24 : Successful call (with the length = 0 and the offset = length of the comparaison buffer)
        testCaseNb = (byte) 25 ;
        bRes = false ;
        
        try {
            // Search tag 8Fh
            if(EnvRespHdlr.findAndCopyValue((byte)0x8F, (byte)1, (short)0, dstBuffer, (short)dstBuffer.length, (short)0)==(short)16)
				bRes = true ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

    }
}
