//-----------------------------------------------------------------------------
//    API_2_ERH_POSTB_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_erh_postb;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeResponseHandler.post()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ERH_POSTB_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    //private ToolkitRegistry obReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

	// Number of tests
    byte testCaseNb = (byte) 0x00;
    
	/**
     * Constructor of the applet
     */
    public API_2_ERH_POSTB_1 () 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ERH_POSTB_1  thisApplet = new API_2_ERH_POSTB_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

		
        

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();

	    switch ( testCaseNb ) 
		{
			case (byte) 0 :
				// --------------------------------------------
				// Test Case 1 : use the methode post(SW1_RP_ACK) without make an appendTLV()
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					
					envRespHdlr.post((byte)SW1_RP_ACK);
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				return;
				
			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : use the methode post(SW1_RP_ACK)
				testCaseNb = (byte) 2 ;

				bRes = false ;
				try {
					byte[] SMS_TPDU_Value2=new byte[0x0101];
					
					Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x00FD,(byte)0x55);
					
					envRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x00FA);

					envRespHdlr.post((byte)SW1_RP_ACK);
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				return;
			
			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : use the methode appendTLV after the using of the post(SW1_RP_ACK) methode 
				testCaseNb = (byte) 3 ;

				bRes = false ;
				try {
					byte[] SMS_TPDU_Value2=new byte[0x0010];
					Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x0010,(byte)0x55);
					envRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x0010);
					envRespHdlr.post((byte)SW1_RP_ACK);
					
					try {
						envRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x0010);
						bRes = false;
					}
					catch (ToolkitException e)    {    
						if(e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE)
							bRes = true ;
					}
				}			
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				return;
				
		case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : use the methode post(SW1_RP_ERROR) and send a display text
				testCaseNb = (byte) 4 ;

				bRes = false ;
				try {
					byte[] SMS_TPDU_Value2=new byte[0x0010];
					Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x0010,(byte)0x55);
					envRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x0010);
					envRespHdlr.post((byte)SW1_RP_ERROR);
					
					//send the proactive command
					proHdlr.initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
					proHdlr.send();
					
					bRes = true;
				}
				
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				return;
		
			case (byte) 4 :
				// --------------------------------------------
				// Test Case 5: use the methode post() without appendTLV() and send a display text
				testCaseNb = (byte) 5 ;

				bRes = false ;
				try {
					
					envRespHdlr.post((byte)SW1_RP_ERROR);
					
					//send the proactive command
					proHdlr.initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
					proHdlr.send();
					
					bRes = true;
				}
				
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				return;
				
		case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : use the post() methode after a display text command
				testCaseNb = (byte) 6 ;

				bRes = false ;
				try{
					byte[] SMS_TPDU_Value2=new byte[0x0010];
					Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x0010,(byte)0x55);
					
					envRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x0010);
					
					//send the proactive command
					proHdlr.initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
					proHdlr.send();
				
					try {
						envRespHdlr.post((byte)SW1_RP_ERROR);
						bRes = false;
					}
				
					catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE)
						bRes = true ;
					}
				}			
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				return;
		
		case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : try to use the methode post(SW1_RP_ACK) after the using of the methode post(SW1_RP_ERROR) 
				testCaseNb = (byte) 7 ;

				bRes = false ;
				try {
					byte[] SMS_TPDU_Value2=new byte[0x0010];
					Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x0010,(byte)0x55);
					
					envRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x0010);
					
					envRespHdlr.post((byte)SW1_RP_ERROR);
					envRespHdlr.post((byte)SW1_RP_ACK);

					bRes = false;
				}
				
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE)
						bRes = true ;
				}			
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				return;		}
	}
}
